import java.io.*;

public class Q1_DKeller<Elementtyp> implements Q1_SpeicherMitTyp<Elementtyp>
 // Keller unter Verwendung einer Datei (Achtung: es knnen z.Z. nicht mehrere
 // Keller verwendet werden, da nur ein Dateiname festgelegt ist -- statt fr jeden Keller ein neuer)
 // R. Krell fr IFQ1M, 30.1.2013
{
  String dateiname = "Q1_KellerD.txt";

  public Q1_DKeller()
  {
    try
    {
      ObjectOutputStream datei = new ObjectOutputStream(new FileOutputStream(dateiname));
      datei.close();
    }
    catch (Exception e)
    {  System.out.println("Konstruktor"); }
  }

  public void rein (Elementtyp neuesElement)
  {
    try
    {
      benenneAlsBackup (dateiname);
      ObjectInputStream alt = new ObjectInputStream(new FileInputStream(dateiname+'$'));
      ObjectOutputStream neu = new ObjectOutputStream(new FileOutputStream(dateiname));
      neu.writeObject(neuesElement);
      try
      {
        while (true)
        {
          neu.writeObject(alt.readObject());
        }
      }
      catch (EOFException eof)
      {
        alt.close();
        neu.close();
      }
    }
    catch (Exception e)
    {  System.out.println("rein"); }
  }
  
  @SuppressWarnings("unchecked")
  public Elementtyp raus ()
  {
    Elementtyp zuLschendesElement = null;
    try
    {
      benenneAlsBackup (dateiname);
      ObjectInputStream alt = new ObjectInputStream(new FileInputStream(dateiname+'$'));
      ObjectOutputStream neu = new ObjectOutputStream(new FileOutputStream(dateiname));
      zuLschendesElement = (Elementtyp) alt.readObject();
      try
      {
        while (true)
        {
          neu.writeObject(alt.readObject());
        }
      }
      catch (EOFException eof)
      {
        alt.close();
        neu.close();
      }
    }
    catch (Exception e)
    { System.out.println("raus"); }
    return (zuLschendesElement);
  }
  
  @SuppressWarnings("unchecked")
  public Elementtyp zeige1 ()
  {
    Elementtyp neuesteElement = null;
    try
    {
      ObjectInputStream datei = new ObjectInputStream(new FileInputStream(dateiname));
      neuesteElement = (Elementtyp) datei.readObject();
      datei.close();
    }
    catch (Exception e)
    { System.out.println("zeige1"); }
    return (neuesteElement);
  }
  
  public boolean istLeer ()
  {
    try
    {
      ObjectInputStream datei = new ObjectInputStream(new FileInputStream(dateiname));
      try
      {
        Object irgendwas = datei.readObject();
      }
      catch (EOFException eof)
      {
        return (true);
      }
      datei.close();
    }
    catch (Exception e)
    { System.out.println("istFehler"); }
    return (false);
  }

  private void benenneAlsBackup (String dateiName)
  // benennt vorhandene Datei durch Anhngen von '$' um, damit auch nach versehentlichem
  // berschreiben die jeweils letzte Fassung als Backup mit '$' gerettet werden kann
  {
    File neu = new File (dateiName);     // bisheriger Dateiname
    File alt = new File (dateiName+"$"); // neuer Name (Backup)
    if (neu.exists())     // Backup/Umbennen nur von existenter Datei ntig/mglich
    {
      if (alt.exists())   // evtl. noch lteres Backup gleichen Namens ..
      {
        alt.delete();     // .. wird gelscht, um Platz fr neues Backup zu schaffen
      }
      neu.renameTo (alt); // Umbenennen in Backup
    }
  }
}